/******************************
 MCL-C Translator
 Scanner (mcl.l)
 
 GPL licensed - (c) 2006
 
                      3 marcos
******************************/

%{
#include <string.h>
#include <stdio.h>
#include "mcl.tab.h"
u_short num_linea=1;
%}

NUMERO	[0-9]
NOME	[A-Za-z_]


%%

	/* keywords */
begin	return MBEGIN;
end	return END;
if	return IF;
fi	return FI;
else	return ELSE;
while	return WHILE;
elihw	return ELIHW;
program	return PROGRAM;

	/**** operatori matematici ****/
("+"|"-")	{strcpy (yylval.stringa, yytext); return OPMATE1;}

("*"|"/")	{strcpy (yylval.stringa, yytext); return OPMATE2;}

	/**** operatori logici ****/
(">"|"<")	{strcpy (yylval.stringa, yytext); return OPLOGIC;}
"!"	return NOT;

"="	return UGUALE;
	
	/**** usato per gestire l'input: a$ legge e mette in a ******/
"$"	return GET;

	/**** parentesi ****/
"("	return PARENTESI_AP;
")"	return PARENTESI_CH;

	/**** virgola...separa attributi/parametri ****/
","	return VIRGOLA;

"||"	return OR;

"&&"	return AND;

exit	return EXIT;

\n	{num_linea++; return FINELINEA;}

;	return PUNTOVIRGOLA;

	/**** identificatore numeri ****/
{NUMERO}+("."{NUMERO}+)?	{strcpy (yylval.stringa, yytext); return NUMERO;}

	/**** identificatore variabili ****/
{NOME}({NOME}|{NUMERO})*	{strcpy (yylval.stringa, yytext); return TEXT;}

	/**** commenti ****/
"#"[^\n]*	{strcpy (yylval.stringa, yytext); return COMMENTO;}	

	/**** frasi ****/
"'"[^\']*\'	{strcpy (yylval.stringa, yytext); return FRASE;}

<<EOF>>	yyterminate();

" "	;	// eliminiamo lo spazio
\t	;	//eliminiamo il tab

.	{
		printf ("*** Scanner: carattere non riconosciuto alla linea %d: %s\n",num_linea, yytext);
		exit(1);
	}

%%

